﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using IdeaBlade.EntityModel;
using System.Security.Principal;
using DomainModel;

namespace DomainModel {
  public class RemoteServiceMethods {
    [AllowRpc]
    public static Object RetrieveAssortedData(IPrincipal principal,
        EntityManager mgr, params Object[] args) {

      // Cast EntityManager to its more specialized type for this app
      NorthwindIBEntityManager domainMgr = (NorthwindIBEntityManager)mgr;

      //Retrieve data, forcing immediate execution with ToList();
      domainMgr.Employees.Include(Employee.EntityPropertyNames.Orders + "." + Order.EntityPropertyNames.OrderDetails).ToList();

      EntityCacheState ecs = domainMgr.CacheStateManager.GetCacheState();
      return ecs;
    }

  }
}