﻿Imports System.Web
Imports IdeaBlade.EntityModel
Imports System.Security.Principal
Imports DomainModel

Namespace DomainModel
  Public Class RemoteServiceMethods
	<AllowRpc>
	Public Shared Function RetrieveAssortedData(ByVal principal As IPrincipal, ByVal mgr As EntityManager, ParamArray ByVal args() As Object) As Object

	  ' Cast EntityManager to its more specialized type for this app
	  Dim domainMgr As NorthwindIBEntityManager = CType(mgr, NorthwindIBEntityManager)

	  'Retrieve data, forcing immediate execution with ToList();
	  domainMgr.Employees.Include(Employee.EntityPropertyNames.Orders & "." & Order.EntityPropertyNames.OrderDetails).ToList()

	  Dim ecs As EntityCacheState = domainMgr.CacheStateManager.GetCacheState()
	  Return ecs
	End Function

  End Class
End Namespace